#= require spec_helper
#= require slender_data/queries/base_query

describe 'slender_data.BaseQuery', ->

  beforeEach ->
    define_test_data this


  describe 'selector_name', ->

    it 'returns "id" for id queries', ->
      query = new slender_data.BaseQuery id: 1, @test_params
      expect(query.selector_name()).to.equal 'id'

    it 'returns "ids" for ids queries', ->
      query = new slender_data.BaseQuery ids: [1, 2], @test_params
      expect(query.selector_name()).to.equal 'ids'

    it 'returns "entry" for entry queries', ->
      query = new slender_data.BaseQuery entry: {id: 1}, @test_params
      expect(query.selector_name()).to.equal 'entry'


  describe 'selector_value', ->

    it 'returns the given id for id queries', ->
      query = new slender_data.BaseQuery id: 1, @test_params
      expect(query.selector_value()).to.eql 1

    it 'returns the given entry for entry queries', ->
      query = new slender_data.BaseQuery entry: {id: 1}, @test_params
      expect(query.selector_value()).to.eql {id: 1}


  describe 'to_hash', ->

    it 'returns the hash representation of this query', ->
      query = new slender_data.BaseQuery id: 3, @test_params
      expect(query.to_hash()).to.eql {id: 3}

